#!/bin/sh

#
# qmail-install.sh: custom qmail installer script
# NOTE: this installer script will **not** work with a regular qmail
#       installation!  This script was written for and is meant to be used by
#       RPM when building the qmail source code for Linux Mandrake systems.
# Please direct any questions/suggestions/etc. to vdanen@mandrakesoft.com.
#
# 10/28/00 - add supervise directory for qmail-pop3d
# 02/25/01 - add supervise directory for qmail-qmqpd
# 08/15/02 - remove all calls to install with ownership so we can build the
#            rpm as non-root if qmail is already installed on the build system

#
# Variables to be passed from qmail.spec:
# RPM_BUILD_ROOT, RPM_BUILD_DIR, QDIR, NAME, VERSION
#

# make directories
install -d -m755 $RPM_BUILD_ROOT$QDIR
for i in bin boot control doc man users; do
  install -d -m755 $RPM_BUILD_ROOT$QDIR/$i
done

for i in man1 man5 man7 man8; do
  install -d -m755 $RPM_BUILD_ROOT$QDIR/man/$i
done

#for i in cat1 cat5 cat7 cat8; do
#  install -d -m755 $RPM_BUILD_ROOT$QDIR/man/$i
#done

install -d -m755 $RPM_BUILD_ROOT$QDIR/supervise
for i in qmail-send qmail-smtpd qmail-pop3d qmail-qmqpd ; do
  install -d -m1755 $RPM_BUILD_ROOT$QDIR/supervise/$i
  install -d -m755 $RPM_BUILD_ROOT$QDIR/supervise/$i/log
done

install -d -m750 $RPM_BUILD_ROOT$QDIR/queue
install -d -m2755 $RPM_BUILD_ROOT$QDIR/alias

install -d -m755 $RPM_BUILD_ROOT/var/log/qmail
install -d -m755 $RPM_BUILD_ROOT/var/log/qmail/smtpd
install -d -m755 $RPM_BUILD_ROOT/var/log/qmail/pop3d
install -d -m755 $RPM_BUILD_ROOT/var/log/qmail/qmqpd


# install binaries
for i in bouncesaying condredirect config-fast datemail elq except forward instcheck maildir2mbox maildirmake maildirwatch mailsubj pinq predate preline qail qbiff; do
  install -m755 $RPM_BUILD_DIR/$NAME-$VERSION/$i $RPM_BUILD_ROOT$QDIR/bin
done

for i in qmail-clean qmail-getpw qmail-local qmail-popup qmail-pw2u qmail-remote qmail-rspawn qmail-send splogger; do
  install -m711 $RPM_BUILD_DIR/$NAME-$VERSION/$i $RPM_BUILD_ROOT$QDIR/bin
done

for i in qmail-lspawn qmail-newmrh qmail-newu qmail-start; do
  install -m700 $RPM_BUILD_DIR/$NAME-$VERSION/$i $RPM_BUILD_ROOT$QDIR/bin
done

install -m4711 $RPM_BUILD_DIR/$NAME-$VERSION/qmail-queue $RPM_BUILD_ROOT$QDIR/bin

for i in qmail-inject qmail-pop3d qmail-qmqpc qmail-qmqpd qmail-qmtpd qmail-qread qmail-qstat qmail-showctl qmail-smtpd qmail-tcpok qmail-tcpto qreceipt qsmhook sendmail tcp-env; do
  install -m755 $RPM_BUILD_DIR/$NAME-$VERSION/$i $RPM_BUILD_ROOT$QDIR/bin
done

for i in FAQ INSTALL INSTALL.alias INSTALL.ctl INSTALL.ids INSTALL.maildir INSTALL.mbox INSTALL.vsm PIC.local2alias PIC.local2ext PIC.local2local PIC.local2rem PIC.local2virt PIC.nullclient PIC.relaybad PIC.relaygood PIC.rem2local REMOVE.binmail REMOVE.sendmail SENDMAIL TEST.deliver TEST.receive UPGRADE; do
  install -m644 $RPM_BUILD_DIR/$NAME-$VERSION/$i $RPM_BUILD_ROOT$QDIR/doc
done

for i in qreceipt condredirect mailsubj except maildirmake preline tcp-env bouncesaying maildir2mbox qbiff forward maildirwatch; do
  install -m644 $RPM_BUILD_DIR/$NAME-$VERSION/$i.1 $RPM_BUILD_ROOT$QDIR/man/man1
#  install -m644 $RPM_BUILD_DIR/$NAME-$VERSION/$i.0 $RPM_BUILD_ROOT$QDIR/man/cat1
done

for i in qmail-users maildir qmail-header envelopes mbox tcp-environ qmail-control qmail-log addresses dot-qmail; do
  install -m644 $RPM_BUILD_DIR/$NAME-$VERSION/$i.5 $RPM_BUILD_ROOT$QDIR/man/man5
#  install -m644 $RPM_BUILD_DIR/$NAME-$VERSION/$i.0 $RPM_BUILD_ROOT$QDIR/man/cat5
done

for i in qmail-limits forgeries qmail; do
  install -m644 $RPM_BUILD_DIR/$NAME-$VERSION/$i.7 $RPM_BUILD_ROOT$QDIR/man/man7
#  install -m644 $RPM_BUILD_DIR/$NAME-$VERSION/$i.0 $RPM_BUILD_ROOT$QDIR/man/cat7
done

for i in qmail-tcpto qmail-qread splogger qmail-start qmail-qmqpc qmail-newu qmail-tcpok qmail-pop3d qmail-inject qmail-clean qmail-getpw qmail-command qmail-showctl qmail-rspawn qmail-smtpd qmail-qmqpd qmail-qstat qmail-pw2u qmail-qmtpd qmail-queue qmail-popup qmail-lspawn qmail-newmrh qmail-local qmail-send qmail-remote; do
  install -m644 $RPM_BUILD_DIR/$NAME-$VERSION/$i.8 $RPM_BUILD_ROOT$QDIR/man/man8
#  install -m644 $RPM_BUILD_DIR/$NAME-$VERSION/$i.0 $RPM_BUILD_ROOT$QDIR/man/cat8
done

for i in home home+df binm1 binm2+df proc+df binm2 binm3 proc binm3+df binm1+df; do
  install -m755 $RPM_BUILD_DIR/$NAME-$VERSION/$i $RPM_BUILD_ROOT$QDIR/boot
done

# build the queue
for i in bounce info intd local lock mess pid remote todo; do
  install -d $RPM_BUILD_ROOT/$QDIR/queue/$i
done

for d in info local mess remote; do
  for i in 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22; do
    install -d $RPM_BUILD_ROOT/$QDIR/queue/$d/$i
  done
done

touch $RPM_BUILD_ROOT$QDIR/queue/lock/sendmutex
# we just touch tcpto, but the qmail.spec file must generate a proper tcpto
# file using bin/qmail-tcpok (use %post)
touch $RPM_BUILD_ROOT$QDIR/queue/lock/tcpto
mkfifo -m 0622 $RPM_BUILD_ROOT$QDIR/queue/lock/trigger

#install -m600 $RPM_BUILD_DIR/$NAME-$VERSION/sendmutex $RPM_BUILD_ROOT$QDIR/queue/lock
#install -m644 $RPM_BUILD_DIR/$NAME-$VERSION/tcpto $RPM_BUILD_ROOT$QDIR/queue/lock
# mkfifo -m 0622 $RPM_BUILD_ROOT$QDIR/queue/lock/trigger
#install -m622 $RPM_BUILD_DIR/$NAME-$VERSION/trigger $RPM_BUILD_ROOT$QDIR/queue/lock

